> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.pinnacle.sh/v-2/api-reference/conversations/list/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.pinnacle.sh/_mcp/server. # List Conversations POST https://api.pinnacle.sh/conversations/list Content-Type: application/json Retrieves conversations by page with optional filtering based off provided parameters. Reference: https://docs.pinnacle.sh/api-reference/conversations/list ## Authentication - `PINNACLE-API-KEY` header (required) — API Key authentication via header ## Request ### Body (application/json) This endpoint expects a ListConversationsRequest. - `pageIndex` (integer, required) — Zero-based index for pagination. - `brandId` (string, optional) — The unique identifier of the brand to filter conversations. This identifier is a string that always begins with the prefix `b_`, for example: `b_1234567890`. - `campaignId` (string, optional) — The unique identifier of the campaign to filter conversations. This identifier is a string that begins with the prefix: - TOLL_FREE: `tf_` (e.g., `tf_1234567890`) - 10DLC: `dlc_` (e.g., `dlc_1234567890`) - RCS: `rcs_` (e.g., `rcs_1234567890`) - `campaignType` (enum, optional) — The type of campaign: - TOLL_FREE: Toll-free number campaigns - 10DLC: 10-digit long code campaigns for A2P messaging - RCS: Rich Communication Services campaigns - Allowed values: `TOLL_FREE`, `10DLC`, `RCS` - `pageSize` (integer, optional, default: 10) — Number of conversations to return per page. - `receiver` (string, optional) — Receiver's phone number in E.164 format. - `sender` (string, optional) — The sender identifier. Can be either: - A phone number in E.164 format - An RCS agent ID prefixed with 'agent_' ## Response ### 200 Returns conversations that meets your filters. - `count` (integer, required) — Total number of conversations matching the filter. - `conversations` (list of Conversation, required) - `hasMore` (boolean, required) — Indicates if more conversations are available beyond the current page. ## Errors ### 400 Bad Request Error Validation failed. The payload has missing required fields and/or invalid types. See [https://zod.dev/error-formatting](https://zod.dev/error-formatting) for more information. - `description` (string, required) — Human-readable summary of validation failures. - `errors` (ZodErrorErrors, required) — Structured dictionary of issues containing two main sections: - `errors`: Array of global validation errors not tied to specific fields - `properties`: Object mapping field names to their specific validation errors, where each field contains an `errors` array ### 401 Unauthorized Error The request lacks valid authentication credentials or the provided credentials are invalid. Ensure you're including a valid API key in the request headers and that your account has the necessary permissions to access this endpoint. - `error` (string, required) — Human-readable description of the error that occurred, corresponding to the HTTP status code. ### 403 Forbidden Error Your subscription does not include access to this feature. This occurs when attempting to use functionality that requires a higher subscription tier. Please upgrade your subscription to access this feature. - `error` (string, required) — Human-readable description of the error that occurred, corresponding to the HTTP status code. ### 500 Internal Server Error An unexpected error occurred on Pinnacle's servers while processing your request. If this error persists, please contact support with the request details. - `error` (string, required) — Human-readable description of the error that occurred, corresponding to the HTTP status code. ## Types ### Conversation Conversation that was found. - `brandId` (string, required, nullable) — The unique identifier of the brand associated with this conversation. This identifier is a string that always begins with the prefix `b_`, for example: `b_1234567890`. - `campaign` (CampaignQuery, required, nullable) — Campaign information if this conversation is part of a marketing campaign. This is an object that contains the campaign ID and type. - `contact` (ConversationContact, required) — Contact information for the recipient in a conversation. - `createdAt` (string, required) — ISO 8601 timestamp when the conversation was created. - `id` (string, required) — Unique identifier for the conversation. This identifier is a string that always begins with the prefix `conv_`, for example: `conv_1234567890`. - `notes` (string, required) — Free-form notes or comments about the conversation. - `sender` (ConversationSender, required, nullable) — The sender of messages in this conversation. Can be: - A phone number with its capabilities and metadata - An RCS agent with ID and name - `null` if no sender is associated - `updatedAt` (string, required) — ISO 8601 timestamp when the conversation was last updated. ### ZodErrorErrors Structured dictionary of issues containing two main sections: - `errors`: Array of global validation errors not tied to specific fields - `properties`: Object mapping field names to their specific validation errors, where each field contains an `errors` array ### CampaignQuery Information about the campaign associated with a conversation - `id` (string, required) — Unique identifier for the campaign. This identifier is a string that begins with the prefix: - TOLL_FREE: `tf_` (e.g., `tf_1234567890`) - 10DLC: `dlc_` (e.g., `dlc_1234567890`) - RCS: `rcs_` (e.g., `rcs_1234567890`) - `type` (enum, required) — The type of campaign: - TOLL_FREE: Toll-free number campaigns - 10DLC: 10-digit long code campaigns for A2P messaging - RCS: Rich Communication Services campaigns - Allowed values: `TOLL_FREE`, `10DLC`, `RCS` ### ConversationContact Contact information for the recipient in a conversation. - `id` (string, required) — Unique ID of the contact. This identifier is a string that always begins with the prefix `co_`, for example: `co_1234567890`. - `phoneNumber` (string, required) — The contact's phone number in E.164 format. ### ConversationSender The sender of messages in this conversation. Can be: - A phone number with its capabilities and metadata - An RCS agent with ID and name - `null` if no sender is associated ### Phone Information about a phone number sender in a conversation. - `capabilities` (PhoneCapabilities, required) — Represents the communication capabilities available for a phone number. - `createdAt` (string, required) — ISO 8601 timestamp when the phone sender was created. - `isSandbox` (boolean, required) — Whether this phone number is in sandbox/testing mode. - `phoneNumber` (string, required) — The sender's phone number in E.164 format. - `updatedAt` (string, required) — ISO 8601 timestamp when the phone sender was last updated ### Agent Information about an RCS agent sender in a conversation. - `agentId` (string, required) — Unique identifier for the RCS agent. - `agentName` (string, required) — Display name of the RCS agent. ### PhoneCapabilities Represents the communication capabilities available for a phone number. - `mms` (boolean, required) — Whether the phone number supports MMS (multimedia messaging). - `sms` (boolean, required) — Whether the phone number supports SMS messaging. - `voice` (boolean, required) — Whether the phone number supports voice calls. ## Examples ### Conversations List **Response** ```json { "count": 50, "conversations": [ { "brandId": "b_1234567890", "campaign": { "id": "dlc_1234567890", "type": "10DLC" }, "contact": { "id": "co_1234567890", "phoneNumber": "+16509231662" }, "createdAt": "2024-09-11T00:05:29.434", "id": "conv_1234567890", "notes": "VIP customer", "sender": { "capabilities": { "mms": true, "sms": true, "voice": false }, "createdAt": "2024-01-15T09:30:00Z", "isSandbox": false, "phoneNumber": "+18445551234", "updatedAt": "2024-01-15T09:30:00Z" }, "updatedAt": "2024-08-14T14:19:40.237" } ], "hasMore": true } ``` **SDK Code** ```python Conversations List import requests url = "https://api.pinnacle.sh/conversations/list" headers = {"PINNACLE-API-KEY": ""} response = requests.post(url, headers=headers) print(response.json()) ``` ```javascript Conversations List const url = 'https://api.pinnacle.sh/conversations/list'; const options = {method: 'POST', headers: {'PINNACLE-API-KEY': ''}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Conversations List package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.pinnacle.sh/conversations/list" req, _ := http.NewRequest("POST", url, nil) req.Header.Add("PINNACLE-API-KEY", "") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Conversations List require 'uri' require 'net/http' url = URI("https://api.pinnacle.sh/conversations/list") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["PINNACLE-API-KEY"] = '' response = http.request(request) puts response.read_body ``` ```java Conversations List import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.pinnacle.sh/conversations/list") .header("PINNACLE-API-KEY", "") .asString(); ``` ```php Conversations List request('POST', 'https://api.pinnacle.sh/conversations/list', [ 'headers' => [ 'PINNACLE-API-KEY' => '', ], ]); echo $response->getBody(); ``` ```csharp Conversations List using RestSharp; var client = new RestClient("https://api.pinnacle.sh/conversations/list"); var request = new RestRequest(Method.POST); request.AddHeader("PINNACLE-API-KEY", ""); IRestResponse response = client.Execute(request); ``` ```swift Conversations List import Foundation let headers = ["PINNACLE-API-KEY": ""] let request = NSMutableURLRequest(url: NSURL(string: "https://api.pinnacle.sh/conversations/list")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### conversations_list_example **Request** ```json { "pageIndex": 0, "brandId": "b_1234567890", "campaignId": "tf_1234567890", "campaignType": "TOLL_FREE", "pageSize": 20, "receiver": "+16509231662", "sender": "+18445551234" } ``` **Response** ```json { "count": 50, "conversations": [ { "brandId": "b_1234567890", "campaign": { "id": "dlc_1234567890", "type": "10DLC" }, "contact": { "id": "co_1234567890", "phoneNumber": "+16509231662" }, "createdAt": "2024-09-11T00:05:29.434", "id": "conv_1234567890", "notes": "VIP customer", "sender": { "capabilities": { "mms": true, "sms": true, "voice": false }, "createdAt": "2024-01-15T09:30:00Z", "isSandbox": false, "phoneNumber": "+18445551234", "updatedAt": "2024-01-15T09:30:00Z" }, "updatedAt": "2024-08-14T14:19:40.237" } ], "hasMore": true } ``` **SDK Code** ```python conversations_list_example import requests url = "https://api.pinnacle.sh/conversations/list" payload = { "pageIndex": 0, "brandId": "b_1234567890", "campaignId": "tf_1234567890", "campaignType": "TOLL_FREE", "pageSize": 20, "receiver": "+16509231662", "sender": "+18445551234" } headers = { "PINNACLE-API-KEY": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript conversations_list_example const url = 'https://api.pinnacle.sh/conversations/list'; const options = { method: 'POST', headers: {'PINNACLE-API-KEY': '', 'Content-Type': 'application/json'}, body: '{"pageIndex":0,"brandId":"b_1234567890","campaignId":"tf_1234567890","campaignType":"TOLL_FREE","pageSize":20,"receiver":"+16509231662","sender":"+18445551234"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go conversations_list_example package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.pinnacle.sh/conversations/list" payload := strings.NewReader("{\n \"pageIndex\": 0,\n \"brandId\": \"b_1234567890\",\n \"campaignId\": \"tf_1234567890\",\n \"campaignType\": \"TOLL_FREE\",\n \"pageSize\": 20,\n \"receiver\": \"+16509231662\",\n \"sender\": \"+18445551234\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("PINNACLE-API-KEY", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby conversations_list_example require 'uri' require 'net/http' url = URI("https://api.pinnacle.sh/conversations/list") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["PINNACLE-API-KEY"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"pageIndex\": 0,\n \"brandId\": \"b_1234567890\",\n \"campaignId\": \"tf_1234567890\",\n \"campaignType\": \"TOLL_FREE\",\n \"pageSize\": 20,\n \"receiver\": \"+16509231662\",\n \"sender\": \"+18445551234\"\n}" response = http.request(request) puts response.read_body ``` ```java conversations_list_example import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.pinnacle.sh/conversations/list") .header("PINNACLE-API-KEY", "") .header("Content-Type", "application/json") .body("{\n \"pageIndex\": 0,\n \"brandId\": \"b_1234567890\",\n \"campaignId\": \"tf_1234567890\",\n \"campaignType\": \"TOLL_FREE\",\n \"pageSize\": 20,\n \"receiver\": \"+16509231662\",\n \"sender\": \"+18445551234\"\n}") .asString(); ``` ```php conversations_list_example request('POST', 'https://api.pinnacle.sh/conversations/list', [ 'body' => '{ "pageIndex": 0, "brandId": "b_1234567890", "campaignId": "tf_1234567890", "campaignType": "TOLL_FREE", "pageSize": 20, "receiver": "+16509231662", "sender": "+18445551234" }', 'headers' => [ 'Content-Type' => 'application/json', 'PINNACLE-API-KEY' => '', ], ]); echo $response->getBody(); ``` ```csharp conversations_list_example using RestSharp; var client = new RestClient("https://api.pinnacle.sh/conversations/list"); var request = new RestRequest(Method.POST); request.AddHeader("PINNACLE-API-KEY", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"pageIndex\": 0,\n \"brandId\": \"b_1234567890\",\n \"campaignId\": \"tf_1234567890\",\n \"campaignType\": \"TOLL_FREE\",\n \"pageSize\": 20,\n \"receiver\": \"+16509231662\",\n \"sender\": \"+18445551234\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift conversations_list_example import Foundation let headers = [ "PINNACLE-API-KEY": "", "Content-Type": "application/json" ] let parameters = [ "pageIndex": 0, "brandId": "b_1234567890", "campaignId": "tf_1234567890", "campaignType": "TOLL_FREE", "pageSize": 20, "receiver": "+16509231662", "sender": "+18445551234" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.pinnacle.sh/conversations/list")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` > One API for RCS, iMessage, MMS, and SMS. Build, test, and scale every channel — send your first message in minutes, not weeks.